<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'
import { getDictOneApi } from '@/api/common'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'dicKey',
    label: '关键字',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'dicId',
    label: 'ID',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'dicName',
    label: '名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'dicValue',
    label: '值',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'parentId',
    label: '父节点ID',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'description',
    label: '描述',
    component: 'Input',
    componentProps: {
      type: 'textarea'
    },
  },
  {
    field: 'dicStatus',
    label: '状态',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'dicSort',
    label: '排序',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'props',
    label: '属性',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'systemCode',
    label: '系统类型',
    component: 'Select',
    optionApi: async () => {
      const res = await getDictOneApi({
        paramName: 'SystemTypeParam_param',
        systemCode: 'system'
      })
      return res
    },
    componentProps: {
      
    },
  }
])

const rules = reactive({
  dicKey: [required()],
  dicId: [required()],
  dicName: [required()],
  dicValue: [required()],
  systemCode: [required()],
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

